config/routes.rb
Rails.application.routes.draw do
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

  namespace :admin do
    Administrate::NamespaceWithFilter::INCLUDED_RESSOURCES.each do |model|
      resources model do
        member do
          post :publish, to: 'publish#create'
          delete :publish, to: 'publish#destroy', as: :unpublish

          resource :versions, only: [:index], as: "#{model}_versions"
        end
      end
    end

    resources :versions, only: [:index, :show]
  end

  post :metadata, to: 'metadata#create'

  get :docs, to: 'docs#index', as: 'docs'
  get 'docs/*path', to: 'docs#show', as: 'doc'

  root to: 'dashboard#show'
end

app/controllers/admin/application_controller.rb
# frozen_string_literal: true

# All Administrate controllers inherit from this `Admin::ApplicationController`,
# making it the ideal place to put authentication logic or other
# before_actions.
#
# If you want to add pagination or other controller-level concerns,
# you're free to overwrite the RESTful controller actions.
module Admin
  class ApplicationController < Administrate::ApplicationController
    include ControllerBase

    delegate :resource_class, :resource_name, :namespace, to: :resource_resolver
    helper_method :namespace
    helper_method :resource_name
    # Override this value to specify the number of elements to display at a time
    # on index pages. Defaults to 20.
    # def records_per_page
    #   params[:per_page] || 20
    # end
  end
end

app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
  include ControllerBase

  def resource_resolver
    @_resource_resolver ||=
      Administrate::ResourceResolver.new('admin/entries')
  end

  helper_method :namespace
  def namespace
    'admin'
  end

  helper_method :nav_link_state
  def nav_link_state(_resource)
    :inactive
  end
end

app/helpers/admin/application_helper.rb
# frozen_string_literal: true

module Admin::ApplicationHelper
  include Administrate::ApplicationHelper
  include ::ApplicationHelper
end

app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
  include Administrate::ApplicationHelper

  def action_link(resource, action)
    # byebug
    resource = model_name(resource).param_key.underscore if resource.is_a? Class
    link_to(translate_with_resource(action, resource, scope: 'administrate.actions'),
            url_for([action, namespace, resource]),
            class: 'button')
  end

  def translate_with_resource(key, resource, options = {})
    model_name = model_name(resource)
    resource_param = model_name.param_key.underscore
    options = options.dup.reverse_merge(default: [key.to_sym], resource: model_name.human)

    t("#{key}_#{resource_param}", options)
  end

  def resource_index_path(resource)
    path = [namespace, resource]

    path << :index if ActiveModel::Naming.uncountable? model_for_resource(resource)

    path
  end

  def logout_path
    '/logout'
  end

  def markdown(text)
    Kramdown::Document.new(text, input: 'markdown', header_offset: 1).to_html.html_safe
  end

  def preview_url(resource)
    if resource.is_a?(Kathde::Models::Concerns::PreviewToken)
      "#{public_url(resource)}?preview_token=#{resource.preview_token}"
    else
      raise "Cant generate preview url for #{model_name(resource)}"
    end
  end

  def public_url(resource)
    case resource
    when Kommentar
      Rails.application.config.preview_base_url + "kommentar/#{resource.slug}"
    when Wochenrueckblick
      Rails.application.config.preview_base_url + "wochenrueckblick/#{resource.slug}"
    when Tagesreport
      Rails.application.config.preview_base_url + "archiv/#{resource.date.to_s('Y/m/d')}"
    else
      raise "Cant generate public url for #{model_name(resource)}"
    end
  end

  private

  def model_name(resource)
    resource = model_for_resource(resource) unless resource.respond_to? :model_name
    resource.model_name
  end

  def model_for_resource(resource)
    resource.to_s.classify.constantize
  end
end

app/views/admin/application/_collection.html.erb
<%#
# Collection

This partial is used on the `index` and `show` pages
to display a collection of resources in an HTML table.

## Local variables:

- `collection_presenter`:
  An instance of [Administrate::Page::Collection][1].
  The table presenter uses `ResourceDashboard::COLLECTION_ATTRIBUTES` to determine
  the columns displayed in the table
- `resources`:
  An ActiveModel::Relation collection of resources to be displayed in the table.
  By default, the number of resources is limited by pagination
  or by a hard limit to prevent excessive page load times

[1]: http://www.rubydoc.info/gems/administrate/Administrate/Page/Collection
%>

<table aria-labelledby="<%= table_title %>">
  <thead>
    <tr>
      <% collection_presenter.attribute_types.each do |attr_name, attr_type| %>
        <th class="cell-label
        cell-label--<%= attr_type.html_class %>
        cell-label--<%= collection_presenter.ordered_html_class(attr_name) %>"
        scope="col"
        role="columnheader"
        aria-sort="<%= sort_order(collection_presenter.ordered_html_class(attr_name)) %>">
        <%= link_to(sanitized_order_params(page, collection_field_name).merge(
          collection_presenter.order_params_for(attr_name, key: collection_field_name)
        )) do %>
        <%= t(
          "helpers.label.#{collection_presenter.resource_name}.#{attr_name}",
          default: attr_name.to_s,
        ).titleize %>
            <% if collection_presenter.ordered_by?(attr_name) %>
              <span class="cell-label__sort-indicator cell-label__sort-indicator--<%= collection_presenter.ordered_html_class(attr_name) %>">
                <svg aria-hidden="true">
                  <use xlink:href="#icon-up-caret" />
                </svg>
              </span>
            <% end %>
          <% end %>
        </th>
      <% end %>
      <% [valid_action?(:edit, collection_presenter.resource_name),
          valid_action?(:destroy, collection_presenter.resource_name)].count(true).times do %>
        <th scope="col"></th>
      <% end %>
    </tr>
  </thead>

  <tbody>
    <% resources.each do |resource| %>
      <tr class="js-table-row"
          <% if show_action? :show, resource %>
            <%= %(tabindex=0 role=link data-url=#{polymorphic_path([namespace, resource])}) %>
          <% end %>
          >
        <% collection_presenter.attributes_for(resource).each do |attribute| %>
          <td class="cell-data cell-data--<%= attribute.html_class %>">
            <% if collection_presenter.send(:dashboard).class::LINK_ATTRIBUTES.include?(attribute.attribute) && show_action?(:show, resource) -%>
              <a href="<%= polymorphic_path([namespace, resource]) -%>"
                 tabindex="-1"
                 class="action-show"
                 >
                <%= render_field attribute %>
              </a>
            <% else %>
              <%= render_field attribute %>
            <% end -%>
          </td>
        <% end %>

        <% if valid_action? :edit, collection_presenter.resource_name %>
          <td><%= link_to(
            t("administrate.actions.edit_short"),
            [:edit, namespace, resource],
            class: "action-edit",
          ) if show_action? :edit, resource%></td>
        <% end %>

        <% if valid_action? :destroy, collection_presenter.resource_name %>
          <td><%= link_to(
            t("administrate.actions.destroy"),
            [namespace, resource],
            class: "text-color-red",
            method: :delete,
            data: { confirm: t("administrate.actions.confirm") }
          ) if show_action? :destroy, resource %></td>
        <% end %>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/admin/application/_error_notice.html.erb
<h4><%= message %></h4>
<ul>
<% errors.each do |error| %>
  <li><%= error %></li>
<% end %>
</ul>

app/views/admin/application/_flashes.html.erb
<%#
# Flash Partial

This partial renders flash messages on every page.

## Relevant Helpers:

- `flash`:
  Returns a hash,
  where the keys are the type of flash (alert, error, notice, etc)
  and the values are the message to be displayed.
%>

<% if flash.any? %>
  <div class="flashes">
    <% flash.each do |key, value| -%>
      <div class="flash flash-<%= key %>"><%= value.html_safe %></div>
    <% end -%>
  </div>
<% end %>

app/views/admin/application/_form.html.erb
<%#
# Form Partial

This partial is rendered on a resource's `new` and `edit` pages,
and renders all form fields for a resource's editable attributes.

## Local variables:

- `page`:
  An instance of [Administrate::Page::Form][1].
  Contains helper methods to display a form,
  and knows which attributes should be displayed in the resource's form.

[1]: http://www.rubydoc.info/gems/administrate/Administrate/Page/Form
%>

<%= form_for([namespace, page.resource], html: { class: "form" }) do |f| %>
  <% if page.resource.errors.any? %>
    <div id="error_explanation">
      <h2>
        <%= t(
          "administrate.form.errors",
          pluralized_errors: pluralize(page.resource.errors.count, t("administrate.form.error")),
          resource_name: display_resource_name(page.resource_name).singularize
        ) %>
      </h2>

      <ul>
        <% page.resource.errors.full_messages.each do |message| %>
          <li class="flash-error"><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <% page.attributes.each do |attribute| -%>
    <div class="field-unit field-unit--<%= attribute.html_class %> field-unit--<%= requireness(attribute) %>">
      <%= render_field attribute, f: f %>

      <% if help = begin
            t("#{page.resource.model_name.i18n_key}.#{attribute.attribute}.help_html", default: [:"#{attribute.attribute}.help_html", :help_html], raise: true, scope: [:fields, attribute.class.send(:field_type)])
          rescue I18n::MissingTranslationData => e
            false
          end then %>
        <div class="field-unit__help">
          <%= help %>
        </div>
      <% end %>
    </div>
  <% end -%>

  <% if page.resource.respond_to?(:hinweistext) %>
    <div class="form-hinweistext">
      <%= markdown page.resource.hinweistext %>
    </div>
  <% end %>
  <div class="form-actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/admin/application/_referenced_collection.html.erb
<%#
# Collection

This partial is used on the `index` and `show` pages
to display a collection of resources in an HTML table.

## Local variables:

- `collection_presenter`:
  An instance of [Administrate::Page::Collection][1].
  The table presenter uses `ResourceDashboard::COLLECTION_ATTRIBUTES` to determine
  the columns displayed in the table
- `resources`:
  An ActiveModel::Relation collection of resources to be displayed in the table.
  By default, the number of resources is limited by pagination
  or by a hard limit to prevent excessive page load times

[1]: http://www.rubydoc.info/gems/administrate/Administrate/Page/Collection
%>

<ol class="referenced-collection-data">

      <% collection_presenter.attribute_types.each do |attr_name, attr_type| %>
        <th class="cell-label
        cell-label--<%= attr_type.html_class %>
        cell-label--<%= collection_presenter.ordered_html_class(attr_name) %>
        " scope="col">
        <%= link_to(sanitized_order_params.merge(
          collection_presenter.order_params_for(attr_name)
        )) do %>
        <%= t(
          "helpers.label.#{resource_name}.#{attr_name}",
          default: attr_name.to_s,
        ).titleize %>

            <% if collection_presenter.ordered_by?(attr_name) %>
              <span class="cell-label__sort-indicator cell-label__sort-indicator--<%= collection_presenter.ordered_html_class(attr_name) %>">
                <%= svg_tag(
                  "administrate/sort_arrow.svg",
                  "sort_arrow",
                  width: "13",
                  height: "13"
                ) %>
              </span>
            <% end %>
          <% end %>
        </th>
      <% end %>
      <th colspan="2" scope="col"></th>
    </tr>
  </thead>

  <% resources.each do |resource| %>
      <li>
        <% collection_presenter.attributes_for(resource).each do |attribute| %>
          <td class="cell-data cell-data--<%= attribute.html_class %>">
            <%= render_field attribute %>
          </td>
        <% end %>

        <td><%= link_to(
          t("administrate.actions.edit"),
          [:edit, namespace, resource],
          class: "action-edit",
        ) %></td>

        <td><%= link_to(
          t("administrate.actions.destroy"),
          [namespace, resource],
          class: "table__action--destroy",
          method: :delete,
          data: { confirm: t("administrate.actions.confirm") }
        ) %></td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/admin/application/_search.html.erb
<form class="search" role="search">
  <span class="search__icon">
    <button type="submit">
      <span class="search__icon__label"><%= t('administrate.actions.search') %></span>
      <svg aria-hidden="true">
        <use xlink:href="#icon-eyeglass" />
      </svg>
    </button>
  </span>

  <input
    id="search"
    type="search"
    name="search"
    class="search__input"
    placeholder="<%= t('administrate.actions.search') %>"
    value="<%= search_term %>"
    aria-label="<%= t('administrate.actions.search') %>"
  />

  <span class="search__hint">
    <%= t('administrate.actions.search_hint') %>
  </span>

  <%= link_to clear_search_params, class: "search__clear-link" do %>
    <svg class="search__clear-icon" role="img">
      <title><%= t("administrate.search.clear") %></title>
      <use xlink:href="#icon-cancel" />
    </svg>
  <% end %>
</form>

app/views/admin/application/_show_sidebar.html.erb
<div class="container__sidebar">
  <%#<div class="versions-preview">
  <%#  <h3>Dieser <%= resource_name > hat <%#= pluralize(page.resource.versions.size, "Version", "Versionen") ></h3>
  <%#
  <%#  <ol class="versions-list">
  <%#    <%= render page.resource.versions.order(created_at: :desc) %>
  <%#  </ol>
  <%#</div>%>
</div>

app/views/admin/application/_sidebar.html.erb
<%#
# Sidebar

This partial is used to display the sidebar in Administrate.
By default, the sidebar contains navigation links
for all resources in the admin dashboard,
as defined by the routes in the `admin/` namespace
%>
<div class="sidebar__inner">
<h1 class="sidebar__title">
  <%= link_to(root_path) do %>
  <span class="site-title">
    <span class="site-title__main">kath.de</span>
    <span class="site-title__sub">Redaktion</span>
  </span>
  <% end %>
</h1>

<div class="sidebar__main">
<% if authorized? %>
  <h3 class="sidebar__section-title"><%= t('sidebar.section.content') %></h3>
  <ul class="sidebar__list">
    <% (Administrate::Namespace.new(namespace).resources).each do |resource| %>
      <li>
        <%=
        link_to(
          display_resource_name(resource.name),
          resource_index_path(resource.path),
          class: "sidebar__link sidebar__link--#{nav_link_state(resource)}"
        ) %>
      </li>
    <% end %>
  </ul>

  <ul class="sidebar__list sidebar__list--secondary">
    <li><%= link_to 'Anleitungen', docs_path, class: "sidebar__link" %></li>
    <li><%= link_to 'Redaktions-Posteingang', 'https://webmail.kath.de/', class: "sidebar__link" %></li>
  </ul>
<% end %>
</div>

<div class="sidebar__footer">
<% if authorized? %>
  <%= link_to t('logout'), logout_path, class: "sidebar__link sidebar__link--logout" %>
  <div class="current_user__username"><%= current_user.username %></div>
<% end %>
</div>
</div>

app/views/admin/application/edit.html.erb
<%#
# Edit

This view is the template for the edit page.

It displays a header, and renders the `_form` partial to do the heavy lifting.

## Local variables:

- `page`:
  An instance of [Administrate::Page::Form][1].
  Contains helper methods to help display a form,
  and knows which attributes should be displayed in the resource's form.

[1]: http://www.rubydoc.info/gems/administrate/Administrate/Page/Form
%>

<% content_for(:title) {
  translate_with_resource(:edit, page.resource_name, scope: 'administrate.actions')
} %>
<% content_for(:header_actions) do %>
  <%= link_to(
    t("administrate.actions.show_resource", name: page.page_title),
    [namespace, page.resource],
    class: "button",
  ) if false && valid_action?(:show) && show_action?(:show, page.resource) %>
<% end %>

<section class="main-content__body container">
  <%= render "form", page: page %>
</section>

app/views/admin/application/index.html.erb
<%#
# Index

This view is the template for the index page.
It is responsible for rendering the search bar, header and pagination.
It renders the `_table` partial to display details about the resources.

## Local variables:

- `page`:
  An instance of [Administrate::Page::Collection][1].
  Contains helper methods to help display a table,
  and knows which attributes should be displayed in the resource's table.
- `resources`:
  An instance of `ActiveRecord::Relation` containing the resources
  that match the user's search criteria.
  By default, these resources are passed to the table partial to be displayed.
- `search_term`:
  A string containing the term the user has searched for, if any.
- `show_search_bar`:
  A boolean that determines if the search bar should be shown.

[1]: http://www.rubydoc.info/gems/administrate/Administrate/Page/Collection
%>

<% content_for(:title) do %>
  <%= display_resource_name(page.resource_name) %>
<% end %>

<% content_for(:search) do %>
  <div class="search-container">
    <%= render(
      "search",
      search_term: search_term,
      resource_name: display_resource_name(page.resource_name)
    ) %>

    <div class="filter-suggestions">
      <% page.send(:dashboard).filter_suggestions(page, current_user).each do |suggestion| %>
        <%= link_to(suggestion, search: suggestion) %>
      <% end %>
    </div>
  </div>
<% end if show_search_bar %>

<% content_for(:header_actions) do %>
  <%= link_to(
      translate_with_resource(:new, page.resource_name, scope: 'administrate.actions'),
      [:new, namespace, page.resource_path],
      class: "button",
    ) if valid_action?(:new) && show_action?(:new, new_resource) %>
<% end %>

<section class="main-content__body main-content__body--flush container">
  <%= render(
    "collection",
    collection_presenter: page,
    collection_field_name: resource_name,
    page: page,
    resources: resources,
    table_title: "page-title"
  ) %>

  <%= paginate resources %>
</section>

app/views/admin/application/new.html.erb
<%#
# New

This view is the template for the "new resource" page.
It displays a header, and then renders the `_form` partial
to do the heavy lifting.

## Local variables:

- `page`:
  An instance of [Administrate::Page::Form][1].
  Contains helper methods to help display a form,
  and knows which attributes should be displayed in the resource's form.

[1]: http://www.rubydoc.info/gems/administrate/Administrate/Page/Form
%>

<% content_for(:title) do %>
  <%= translate_with_resource(:new, page.resource_name, scope: 'administrate.actions') %>
<% end %>

<% content_for(:header_actions) do %>
  <%= link_to t("administrate.actions.back"), :back, class: "button" %>
<% end %>

<section class="main-content__body container">
  <%= render "form", page: page %>
</section>

app/views/admin/application/show.html.erb
<%#
# Show

This view is the template for the show page.
It renders the attributes of a resource,
as well as a link to its edit page.

## Local variables:

- `page`:
  An instance of [Administrate::Page::Show][1].
  Contains methods for accessing the resource to be displayed on the page,
  as well as helpers for describing how each attribute of the resource
  should be displayed.

[1]: http://www.rubydoc.info/gems/administrate/Administrate/Page/Show
%>

<% content_for(:title) { t("administrate.actions.show_resource", name: page.page_title) } %>

<% content_for(:header_actions) do %>
  <%= link_to(
    translate_with_resource(:edit_short, resource_name, scope: 'administrate.actions'),
    [:edit, namespace, page.resource],
    class: "button",
  ) if valid_action?(:edit) && show_action?(:edit, page.resource) %>
<% end %>

<section class="main-content__body container">
  <dl class="container__main">
    <% page.attributes.each do |attribute| %>
      <dt class="attribute-label" id="<%= attribute.name %>">
      <%= t(
        "helpers.label.#{resource_name}.#{attribute.name}",
        default: attribute.name.titleize,
      ) %>
      </dt>

      <dd class="attribute-data attribute-data--<%=attribute.html_class%>"
          ><%= render_field attribute, page: page %></dd>
    <% end %>
  </dl>

  <%= render 'admin/application/show_sidebar', page: page %>
</section>